#pragma rtGlobals=1		/

Menu "Macros"

	"Wavelet transform calculation" ,basew1()

End

Function basew1()

Variable/G ModFun
Variable/G centrum1, sigma1, ampli1,  frequency1, phaseshift1
Variable/G centrum2, sigma2, ampli2,  frequency2, phaseshift2

Variable/G SMorletKappa, SMorletSigma, SnResolution
Variable/G Rmin, Rmax, Raxis, Kmin, Kmax
Variable/G  weight, keyMother, WLparam1, WLparam2
Variable fn
String/G spectrumName, directoryName, mother, OutputFile
String/G CurrentName, Mother, Err
Variable/G indexWAVE
String FileName

killwaves/A/Z

Make/O/N=10 wt0

indexWAVE=0



NewPath/O/Q mypath,"d:IgorProAppl"


FileName="ModelFunction.txt"

LoadWave/O/Q/D/A/N='wt'/P=mypath/G FileName


centrum1=wt0[0];sigma1=wt0[1];ampli1=wt0[2];frequency1=wt0[3];phaseshift1=wt0[4]
centrum2=wt0[5];sigma2=wt0[6];ampli2=wt0[7];frequency2=wt0[8];phaseshift2=wt0[9]

NewPanel /K=1/W=(25,0,815,600) as "WAVELET TRANSFORM" ; 

SetVariable svDir, pos={220,600}, size={280,24}, title="Directory", value=directoryName, limits={0.,15.,0}, format="%r", noproc


Button Model, pos={500,20}, size={215,24}, noproc, title="MODEL FUNCTION"
 
 SetVariable svcen1, pos={500,60}, size={100,24}, title="centrum1", value=centrum1, limits={0.,15.,0}, format="%g", noproc
 SetVariable svsig1, pos={500,90}, size={100,24}, title="sigma1", value=sigma1, limits={0.01,1000.,0}, format="%g", noproc
 SetVariable svamp1, pos={500,120}, size={100,24}, title="ampli1", value=ampli1, limits={0.,100.,0}, format="%g", noproc
 SetVariable svfr1, pos={500,150}, size={100,24}, title="frequency1", value=frequency1, limits={0.,1000.,0}, format="%g", noproc
 SetVariable svph1, pos={500,180}, size={100,24}, title="phase1", value=phaseshift1, limits={-15.,15.,0}, format="%g", noproc

 SetVariable svcen2, pos={620,60}, size={100,24}, title="centrum2", value=centrum2, limits={0.,15.,0}, format="%g", noproc
 SetVariable svsig2, pos={620,90}, size={100,24}, title="sigma2", value=sigma2, limits={0.01,1000.,0}, format="%g", noproc
 SetVariable svamp2, pos={620,120}, size={100,24}, title="ampli2", value=ampli2, limits={0.,100.,0}, format="%g", noproc
 SetVariable svfr2, pos={620,150}, size={100,24}, title="frequency2", value=frequency2, limits={0.,1000.,0}, format="%g", noproc
 SetVariable svph2, pos={620,180}, size={100,24}, title="phase2", value=phaseshift2, limits={-15.,15.,0}, format="%g", noproc
 
 Button SaveModel, pos={500,215}, size={65,24}, proc=SaveMod, title="Save"
 Button CalculationMod, pos={570,215}, size={80,24}, proc=CalcMod, title="Calculation"
 Button DrawModel pos={655,215}, size={65,24}, proc=DrawMod, title="Draw"
 Button CalculationModFFT pos={500,245}, size={105,24}, proc=ModFFT, title="FFT"
 Button CalcDrawMFFT, pos={615,245}, size={105,24}, proc=DrawFFT, title="DrawFFT"



Button Spectrum, pos={15,15}, size={200,24}, noproc, title=" REAL EXAFS SPECTRUM"

spectrumName=""
weight=0. 
 SetVariable svSN, pos={35,70}, size={180,24}, title="file", value=spectrumName, limits={0.,25.,0}, format="%r", noproc
 SetVariable svweigth, pos={35,100}, size={180,24}, title="weight", value=weight, limits={0.,15.,0}, format="%g", noproc
 
Button SaveSpectrum, pos={15,140}, size={55,24}, proc=SaveSpect, title="Save"
Button CalcSpect, pos={75,140}, size={80,24}, proc=CalcSpect, title="Calculation"
Button DrawSpect, pos={160,140}, size={55,24}, proc=DrawSpect, title="Draw"
Button CalcSpectFFT, pos={15,170}, size={90,24}, proc=SpectFFT, title="FFT"
Button CalcDrawSFFT, pos={125,170}, size={90,24}, proc=DrawFFT, title="DrawFFT"

//SetVariable svFileName, pos={20,240}, size={230,24}, title="current file", value=spectrumName, limits={0.,25.,0}, format="%r", noproc
//SetVariable svkmin, pos={260,240}, size={100,24}, title="kmin", value=kmin, limits={0.,15.,0}, format="%g", noproc
//SetVariable svkmax, pos={360,240}, size={100,24}, title="kmax", value=kmax, limits={0.,15.,0}, format="%g", noproc
//SetVariable svkaxis, pos={460,240}, size={100,24}, title="kaxis", value=kaxis, limits={0.,15.,0}, format="%g", noproc
Rmin=.1
Rmax=10.
Raxis=300
SetVariable svRmin, pos={15,255}, size={100,24}, title="RMIN", value=Rmin, limits={0.01,100.,0}, format="%g", noproc
SetVariable svRmax, pos={120,255}, size={100,24}, title="RMAX", value=Rmax, limits={0.01,100.,0}, format="%g", noproc
SetVariable svRaxis, pos={225,255}, size={100,24}, title="RAXIS", value=Raxis, limits={1,1000.,0}, format="%g", noproc

Button Mother, pos={255,310}, size={180,24}, noproc, title="Mother wavelet"
Button Morlet, pos={135,345}, size={180,24}, noproc, title="MORLET"
Button Cauchy, pos={385,345}, size={180,24}, noproc, title="CAUCHY"
SMorletKappa=5
SetVariable svMorletKap, pos={135,380}, size={180,24}, title="kappa", value=SMorletKappa, limits={0.,1000.,0}, format="%g", noproc
SMorletSigma=1
SetVariable svMorletSig, pos={135,405}, size={180,24}, title="sigma", value=SMorletsigma, limits={0.1,1000.,0}, format="%g", noproc

Button SaveMorlet, pos={135,430}, size={40,24}, proc=SaveMotherParam, title="Save"
Button CalculationMorlet, pos={180,430}, size={80,24}, proc=CalculationMorlet, title="Calculation"
Button DrawMor, pos={265,430}, size={48,24}, proc=DrawMother, title="Draw"

SnResolution=10
SetVariable svCauchyRes, pos={385,380}, size={180,24}, title="nResolution", value=SnResolution, limits={0.,10000.,0}, format="%g", noproc

Button SaveCauchy, pos={385,430}, size={40,24}, proc=SaveMotherParam, title="Save"
Button CalculationCauchy, pos={430,430}, size={80,24}, proc=CalculationCauchy, title="Calculation"
Button DrawCau, pos={515,430}, size={48,24}, proc=DrawMother, title="Draw"

SetVariable svFName, pos={5,500}, size={200,24}, title="current file", value=CurrentName, limits={0.,25.,0}, format="%r", noproc
SetVariable svMName, pos={5,560}, size={200,24}, title="mother function", value=Mother, limits={0.,25.,0}, format="%r", noproc

SetVariable svOutputF, pos={5,530}, size={200,24}, title="output file", value=OutputFile, limits={0.,25.,0}, format="%r", noproc
OutputFile="OutputFile"
Button SaveParam, pos={330,530}, size={160,24}, proc=SaveAllParam, title="Save all parameters"
Button CalculationWL, pos={510,530}, size={200,24}, proc=CalcWL, title="Wavelet transform calculation"
Button DrawWL, pos={730,530}, size={50,24}, proc=DrawWL, title="Draw"

//SetVariable svErr, pos={5,530}, size={200,24}, title="output file", value=Err, limits={0.,25.,0}, format="%r", noproc

end
//
//
Function SaveMod(ctrlName) : ButtonControl 
String ctrlName
NVAR centrum1, sigma1, ampli1,  frequency1, phaseshift1
NVAR centrum2, sigma2, ampli2,  frequency2, phaseshift2
NVAR weight
Variable fn

weight=0.

Open/P=mypath/Z fn as "ModelFunction.txt"

 fprintf  fn,"%g\r\n",centrum1
 fprintf  fn,"%g\r\n",sigma1
 fprintf  fn,"%g\r\n", ampli1
 fprintf  fn, "%g\r\n",frequency1
 fprintf  fn, "%g\r\n", phaseshift1
 fprintf  fn, "%g\r\n", centrum2
 fprintf  fn, "%g\r\n", sigma2
 fprintf  fn,"%g\r\n", ampli2
 fprintf  fn, "%g\r\n",frequency2
 fprintf  fn, "%g\r\n", phaseshift2
 
Close fn

End
//
//
Function SaveSpect(ctrlName) : ButtonControl
String ctrlName
NVAR weight
SVAR spectrumName
variable fn

Open/P=mypath/Z fn as "SpectrumFunction.txt"

	 fprintf  fn, "%s\r\n",spectrumName
	 fprintf  fn, "%g\r\n", weight 
Close fn
print spectrumName
End
//
//
Function SaveMotherParam(ctrlName) : ButtonControl
String ctrlName 

NVar SMorletKappa, SMorletSigma, SnResolution
variable fn
Open/P=mypath/Z fn as "MotherParam.txt"

 fprintf  fn,"%g\r\n",SMorletKappa
 fprintf  fn,"%g\r\n",SMorletSigma
 fprintf  fn,"%g\r\n",SnResolution
  
  Close fn
 End 

//
//
Function SaveAllParam(ctrlName) : ButtonControl
String ctrlName
SVAR OutputFile, CurrentName, Mother
NVAR  weight, Rmin, Rmax, Raxis
NVAR keyMother, WLparam1, WLparam2
variable fn, RaxisMinusOne

RaxisMinusOne=Raxis-1
Open/P=mypath/Z fn as "inpParam.txt" 

fprintf  fn, "%s\r\n",OutputFile
fprintf  fn, "%s\r\n",CurrentName
fprintf  fn,"%g\r\n",weight
fprintf  fn,"%g\r\n",Rmin
fprintf  fn,"%g\r\n",Rmax
fprintf  fn,"%g\r\n",Raxis	
fprintf  fn,"%g\r\n",keyMother
fprintf  fn,"%g\r\n",WLparam1
fprintf  fn,"%g\r\n",WLparam2


Close fn	
End
//
//

Function CalcMod(ctrlName) : ButtonControl 
	String ctrlName
SVAR CurrentName
CurrentName="Model"	
	ExecuteScriptText/B "d:\\IgorProAppl\\model.exe"
End
//
//
Function CalcSpect(ctrlName) : ButtonControl
String ctrlName
SVAR CurrentName, spectrumName
CurrentName=spectrumName
ExecuteScriptText/B "d:\\IgorProAppl\\spectrum.exe"
End
//
//
Function ModFFT(ctrlName) : ButtonControl

    String ctrlName
  
ExecuteScriptText/B "d:\\IgorProAppl\\fourier.exe"
End
//
//
Function SpectFFT(ctrlName) : ButtonControl

    String ctrlName
ExecuteScriptText/B "d:\\IgorProAppl\\fourier.exe"
	
End
//
//
Function CalculationMorlet(ctrlName) : ButtonControl

String ctrlName
SVAR Mother
NVAR keyMother, WLparam1, WLparam2
NVAR SMorletKappa, SMorletSigma

keyMother=1
Mother="Morlet"
WLparam1=SMorletKappa
WLparam2=SMorletSigma

ExecuteScriptText/B "d:\\IgorProAppl\\morlet.exe"
End
//
//
Function CalculationCauchy(ctrlName) : ButtonControl

    String ctrlName
    SVAR Mother
    NVAR keyMother, WLparam1, WLparam2
    NVAR SnResolution
  

keyMother=2
Mother="Cauchy"
WLparam1=SnResolution
WLparam2=0


ExecuteScriptText/B "d:\\IgorProAppl\\cauchy.exe"
End
//
//
Function CalcWL(ctrlName) : ButtonControl 
	String ctrlName
ExecuteScriptText "d:\\IgorProAppl\\WL.exe"
End
//
//

Function DrawSpect(ctrlName) : ButtonControl 
	String ctrlName

string FileName
wave wspect

FileName="function.txt"

LoadWave/O/Q/D/A/N=wspect/P=mypath/G FileName
Setscale d 0,0 ,"k-wave, A-1",wspect0
Setscale d 0,0,"EXAFS spectrum",wspect1
Display /K=1/W=(500,5,800,230) wspect1 vs wspect0 as"function.txt"
ModifyGraph grid(left)=1
ModifyGraph grid=1

End
//
//
Function DrawMod(ctrlName) : ButtonControl 
	String ctrlName
	KillWaves/Z/A
	Make/O/N=300 wmod0, wmod1
string FileName

FileName="function.txt"
LoadWave/O/Q/J/D/A/N=wmod/P=mypath/G FileName

Setscale d 0,0 ,"k-wave, A-1",wmod0
Setscale d 0,0,"MODEL function",wmod1
Display /K=1/W=(500,5,800,230) wmod1 vs wmod0 as"function.txt"

ModifyGraph grid(left)=1
ModifyGraph grid=1

 End
//
//
Function DrawFFT(ctrlName) : ButtonControl

    String ctrlName

KillWaves/Z/A
	Make/O/N=300 wfft0, wfft1
string FileName

FileName="Fourier.txt"
LoadWave/O/Q/J/D/A/N=wfft/P=mypath/G FileName

Setscale d 0,0 ,"R, A",wfft0
Setscale d 0,0,"FFT",wfft1
Display /K=1/W=(500,305,800,535) wfft1 vs wfft0 as"fourier.txt"

ModifyGraph grid(left)=1
ModifyGraph grid=1

End
//
//
Function DrawMother(ctrlName) : ButtonControl 
	String ctrlName
	KillWaves/Z/A
	Make/O/N=300 wmother0, wmother1
string FileName

FileName="mother.txt"
LoadWave/O/Q/J/D/A/N=wmother/P=mypath/G FileName

Setscale d 0,0 ,"k-wave, A-1",wmother0
Setscale d 0,0,"Mother wavelet",wmother1
Display /K=1/W=(500,305,800,535) wmother1 vs wmother0 as"mother.txt"

ModifyGraph grid(left)=1
ModifyGraph grid=1


End
//
//
Function DrawWL(ctrlName) : ButtonControl 
	String ctrlName

SVAR OutputFile	
NVAR  Raxis, Rmin, Rmax
variable AllPoints,KaxisIMAGE, Kmin, Kmin1, Kmax, Kmax1
string FileName
LoadWave/O/Q/J/D/A/N=wWL/P=mypath/G OutputFile

wavestats wWL0
AllPoints=V_npnts
KaxisIMAGE=AllPoints/ Raxis
Redimension/N=(KaxisIMAGE,Raxis) wWL0
FileName="function.txt"
LoadWave/O/Q/J/D/A/N=wXF/P=mypath/G FileName
wavestats wXF0
Kmin=V_min
Kmax=V_max
Kmin1=Kmin-(Kmax-Kmin)
Kmax1=Kmax+(Kmax-Kmin)
Display/W=(500,305,800,535) as OutputFile;AppendImage wWL0;
SetScale/I x Kmin1,Kmax1,"", wWL0;DelayUpdate
SetScale/I y Rmin,Rmax,"", wWL0;DelayUpdate
ModifyImage wWL0 ctab= {*,*,Terrain,0}

End